/************************************************************************************************

 Author        : ADI - Apps            www.analog.com/AduC7060

 Date          : November 2007

 File          : Timer0_IRQ.c

 Hardware      : ADuC706x

 Description   : The program shows how to configure Timer0 in periodic mode with an interrupt source.
*************************************************************************************************/
// Bit Definitions
#define BIT0  0x01
#define BIT1  0x02
#define BIT2  0x04
#define BIT3  0x08
#define BIT4  0x10
#define BIT5  0x20
#define BIT6  0x40
#define BIT7  0x80
#define BIT8  0x100
#define BIT9  0x200
#define BIT10 0x400
#define BIT11 0x800
#define BIT12 0x1000
#define BIT13 0x2000
#define BIT14 0x4000
#define BIT15 0x8000
#define BIT22 0x400000
#define BIT30 0x40000000


#include<aduc7060.h>

int main(void)
{
	POWKEY1 = 0x1;
	POWCON0 = 0x78;		   // Set core to max CPU speed of 10.24Mhz
	POWKEY2 = 0xF4;
	GP1DAT  = BIT30;		// Configure P1.6 as an output 
	
	// Initilize Timer 0 in Periodic mode with timeout period of 1 Second
	T0LD  = 0x8000;			// 32768 clock ticks
	T0CON = BIT6 + BIT7;	// Periodic mode, enable timer, 32768hz clock/1
	IRQEN = BIT3;			// Enable Timer 0 IRQ
	
	while(1)
	{
        	
	}
	return (0);
}

void IRQ_Handler(void) __irq  
{
   unsigned long IRQSTATUS = 0;

	IRQSTATUS = IRQSTA;	   // Read off IRQSTA register

	if ((IRQSTATUS & BIT3) == BIT3)	//Timer 0 interrupt source
	{
		 GP1DAT &= ~BIT22;	// Toggle LED on Evaluation board (P1.6)
		 T0CLRI = 0x55;		// Clear the currently active Timer0 Irq
	}
}


